<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from parguide.texi on 28 April 1999 -->

<TITLE>The SUIF Parallelizing Compiler Guide - Running Parallel Programs</TITLE>
<link href="parguide_4.html" rel=Next>
<link href="parguide_2.html" rel=Previous>
<link href="parguide_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="parguide_1.html">first</A>, <A HREF="parguide_2.html">previous</A>, <A HREF="parguide_4.html">next</A>, <A HREF="parguide_6.html">last</A> section, <A HREF="parguide_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC3" HREF="parguide_toc.html#TOC3">Running Parallel Programs</A></H1>

<P>
The number of parallel threads and mapping of threads to physical
processors for SUIF parallelized programs can be set using environment 
variables.
The run-time library reads the following environment variables:

</P>
<DL COMPACT>

<DT><CODE>PL_NUM_THREADS</CODE>
<DD>
The number of parallel threads to execute.  The default is set to 4.

<DT><CODE>PL_PROC_START</CODE>
<DD>
The physical processor number that is to execute the first thread.
For the DASH and SGI run-time libraries the default is set to 4.

<DT><CODE>PL_MAXPROC</CODE>
<DD>
The total number of processors available.  The current default is 48 for
the DASH and SGI libraries.
</DL>

<P>
The run-time libraries assume that the physical processors are numbered 
starting at 0.  
The system creates a number of threads equal to PL_NUM_THREADS.  
The threads are then mapped to physical processors starting
at PL_PROC_START, wrapping at PL_MAXPROC back to processor 0. 
The threads are assigned logical ids from 0 to PL_NUM_THREADS-1.
The original master thread is guaranteed to be thread 0.  

</P>
<P>
Under
the SPMD model, the run-time library starts up a single thread on each
processor.  While one processor executes the sequential portions of
the program, the remaining processors wait at a barrier.  Once a
parallel region is reached, all processors participate in the parallel
computation, and again synchronize at a barrier at the end of the
parallel region.  The SUIF parallelizer generates code according to the
lightweight thread model, where all variables are shared by default.
Only local variables declared within an SPMD region are private; these 
variables are allocated on the local stack of the processor.

</P>
<P><HR><P>
<p>Go to the <A HREF="parguide_1.html">first</A>, <A HREF="parguide_2.html">previous</A>, <A HREF="parguide_4.html">next</A>, <A HREF="parguide_6.html">last</A> section, <A HREF="parguide_toc.html">table of contents</A>.
</BODY>
</HTML>
